<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { NextStep } from '../components/common/index';
import {
  Hero,
  ComparisonChart,
  CaseStudies,
  AccoladeCards as Accolades,
  SdlcTable,
  WhyPrimaryCTA,
  WhyGrowthSection,
  Showcase,
} from '../components/why/index';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    Hero,
    SdlcTable,
    WhyGrowthSection,
    ComparisonChart,
    CaseStudies,
    NextStep,
    WhyPrimaryCTA,
    Accolades,
    Showcase,
  },
  async asyncData({ $content }) {
    const data = await $content('why-gitlab').fetch();
    return {
      data,
    };
  },
  data() {
    return {
      comparisons: 0,
      visibleComparisonIndex: 0,
      nextComparisonIndex: 1,
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).data, this.$route.path);
  },
  methods: {
    updateComparison(currentIndex: number, numberOfComparisons: number) {
      const adjustedIndex = currentIndex + 1;

      if (adjustedIndex < numberOfComparisons) {
        this.visibleComparisonIndex += 1;
      } else {
        this.visibleComparisonIndex = 0;
      }

      if (this.nextComparisonIndex + 1 < numberOfComparisons) {
        this.nextComparisonIndex += 1;
      } else if (this.nextComparisonIndex + 1 === numberOfComparisons) {
        this.nextComparisonIndex = 0;
      }
    },
  },
});
</script>

<template>
  <div class="why">
    <Hero :data="data.hero" />
    <WhyPrimaryCTA :data="data.primary_cta_block" />
    <SdlcTable :data="data.sdlc_table_block" />
    <Showcase :data="data.showcase.data" />
    <WhyGrowthSection :data="data.growth_block" />
    <Accolades :data="data.accolades_block" />
    <ComparisonChart
      :title="data.solution_comparison.title"
      :subtitle="data.solution_comparison.subtitle"
      :link-text="data.solution_comparison.link_text"
      :link-href="data.solution_comparison.link_href"
      :data-ga-name="data.solution_comparison.data_ga_name"
      :data-ga-location="data.solution_comparison.data_ga_location"
      :solutions="data.solution_comparison.solutions"
    />
    <CaseStudies :data="data.case_studies" />
    <NextStep />
  </div>
</template>

<style lang="scss" scoped>
.why {
  overflow-x: hidden;
}

.solution-comparison {
  background: $color-surface-700;
  padding: $spacing-96 0;
  overflow: hidden;
}
</style>
